diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-mlo-test.cc ns-3.38/src/wifi/test/wifi-mlo-test.cc
--- ns-3.37/src/wifi/test/wifi-mlo-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-mlo-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -27,6 +27,7 @@
 #include "ns3/mobility-helper.h"
 #include "ns3/multi-link-element.h"
 #include "ns3/multi-model-spectrum-channel.h"
+#include "ns3/node-list.h"
 #include "ns3/packet-socket-client.h"
 #include "ns3/packet-socket-helper.h"
 #include "ns3/packet-socket-server.h"
@@ -34,17 +35,22 @@
 #include "ns3/pointer.h"
 #include "ns3/qos-utils.h"
 #include "ns3/rng-seed-manager.h"
+#include "ns3/rr-multi-user-scheduler.h"
 #include "ns3/spectrum-wifi-helper.h"
+#include "ns3/spectrum-wifi-phy.h"
 #include "ns3/sta-wifi-mac.h"
 #include "ns3/string.h"
 #include "ns3/test.h"
 #include "ns3/wifi-acknowledgment.h"
 #include "ns3/wifi-assoc-manager.h"
 #include "ns3/wifi-mac-header.h"
+#include "ns3/wifi-mac-queue.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-protection.h"
 #include "ns3/wifi-psdu.h"
 
+#include <algorithm>
+#include <array>
 #include <iomanip>
 #include <sstream>
 #include <vector>
@@ -186,49 +192,32 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
- * \brief Test Multi-Link Discovery & Setup
+ * \brief Base class for Multi-Link Operations tests
  *
  * Three spectrum channels are created, one for each band (2.4 GHz, 5 GHz and 6 GHz).
  * Each PHY object is attached to the spectrum channel corresponding to the PHY band
  * in which it is operating.
  */
-class MultiLinkSetupTest : public TestCase
+class MultiLinkOperationsTestBase : public TestCase
 {
   public:
     /**
      * Constructor
      *
+     * \param name The name of the new TestCase created
+     * \param nStations the number of stations to create
      * \param staChannels the strings specifying the operating channels for the STA
      * \param apChannels the strings specifying the operating channels for the AP
-     * \param setupLinks a list of links (STA link ID, AP link ID) that are expected to be setup
      * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
      */
-    MultiLinkSetupTest(std::initializer_list<std::string> staChannels,
-                       std::initializer_list<std::string> apChannels,
-                       std::initializer_list<std::pair<uint8_t, uint8_t>> setupLinks,
-                       std::initializer_list<uint8_t> fixedPhyBands = {});
-    ~MultiLinkSetupTest() override;
-
-  private:
-    /**
-     * Reset the given PHY helper, use the given strings to set the ChannelSettings
-     * attribute of the PHY objects to create, and attach them to the given spectrum
-     * channels appropriately.
-     *
-     * \param helper the given PHY helper
-     * \param channels the strings specifying the operating channels to configure
-     * \param channelMap the created spectrum channels
-     */
-    void SetChannels(SpectrumWifiPhyHelper& helper,
-                     const std::vector<std::string>& channels,
-                     const std::map<WifiPhyBand, Ptr<MultiModelSpectrumChannel>>& channelMap);
-
-    /**
-     * \param str the given channel string
-     * \return the PHY band specified in the given channel string
-     */
-    WifiPhyBand GetPhyBandFromChannelStr(const std::string& str);
+    MultiLinkOperationsTestBase(const std::string& name,
+                                uint8_t nStations,
+                                std::vector<std::string> staChannels,
+                                std::vector<std::string> apChannels,
+                                std::vector<uint8_t> fixedPhyBands = {});
+    ~MultiLinkOperationsTestBase() override = default;
 
+  protected:
     /**
      * Callback invoked when a FEM passes PSDUs to the PHY.
      *
@@ -238,46 +227,31 @@
      * \param txVector the TX vector
      * \param txPowerW the tx power in Watts
      */
-    void Transmit(uint8_t linkId,
-                  std::string context,
-                  WifiConstPsduMap psduMap,
-                  WifiTxVector txVector,
-                  double txPowerW);
-    /**
-     * Check correctness of Multi-Link Setup procedure.
-     */
-    void CheckMlSetup();
+    virtual void Transmit(uint8_t linkId,
+                          std::string context,
+                          WifiConstPsduMap psduMap,
+                          WifiTxVector txVector,
+                          double txPowerW);
 
-    /**
-     * Check that links that are not setup on the non-AP MLD are disabled.
-     */
-    void CheckDisabledLinks();
+    void DoSetup() override;
 
     /**
-     * Check correctness of the given Beacon frame.
-     *
-     * \param mpdu the given Beacon frame
-     * \param linkId the ID of the link on which the Beacon frame was transmitted
+     * Uplink or Downlink direction
      */
-    void CheckBeacon(Ptr<WifiMpdu> mpdu, uint8_t linkId);
-
-    /**
-     * Check correctness of the given Association Request frame.
-     *
-     * \param mpdu the given Association Request frame
-     * \param linkId the ID of the link on which the Association Request frame was transmitted
-     */
-    void CheckAssocRequest(Ptr<WifiMpdu> mpdu, uint8_t linkId);
+    enum Direction
+    {
+        DL = 0,
+        UL
+    };
 
     /**
-     * Check correctness of the given Association Response frame.
+     * Check that the Address 1 and Address 2 fields of the given PSDU contain device MAC addresses.
      *
-     * \param mpdu the given Association Response frame
-     * \param linkId the ID of the link on which the Association Response frame was transmitted
+     * \param psdu the given PSDU
+     * \param direction indicates direction for management frames (DL or UL)
      */
-    void CheckAssocResponse(Ptr<WifiMpdu> mpdu, uint8_t linkId);
-
-    void DoRun() override;
+    void CheckAddresses(Ptr<const WifiPsdu> psdu,
+                        std::optional<Direction> direction = std::nullopt);
 
     /// Information about transmitted frames
     struct FrameInfo
@@ -288,62 +262,170 @@
         uint8_t linkId;           ///< link ID
     };
 
-    std::vector<FrameInfo> m_txPsdus;       ///< transmitted PSDUs
-    std::vector<std::string> m_staChannels; ///< strings specifying channels for STA
-    std::vector<std::string> m_apChannels;  ///< strings specifying channels for AP
-    std::vector<std::pair<uint8_t, uint8_t>>
-        m_setupLinks;                     ///< expected links to setup (STA link ID, AP link ID)
-    std::vector<uint8_t> m_fixedPhyBands; ///< links on non-AP MLD with fixed PHY band
-    Ptr<ApWifiMac> m_apMac;               ///< AP wifi MAC
-    Ptr<StaWifiMac> m_staMac;             ///< STA wifi MAC
-};
-
-MultiLinkSetupTest::MultiLinkSetupTest(
-    std::initializer_list<std::string> staChannels,
-    std::initializer_list<std::string> apChannels,
-    std::initializer_list<std::pair<uint8_t, uint8_t>> setupLinks,
-    std::initializer_list<uint8_t> fixedPhyBands)
-    : TestCase("Check correctness of Multi-Link Setup"),
+    std::vector<FrameInfo> m_txPsdus;             ///< transmitted PSDUs
+    const std::vector<std::string> m_staChannels; ///< strings specifying channels for STA
+    const std::vector<std::string> m_apChannels;  ///< strings specifying channels for AP
+    const std::vector<uint8_t> m_fixedPhyBands;   ///< links on non-AP MLD with fixed PHY band
+    Ptr<ApWifiMac> m_apMac;                       ///< AP wifi MAC
+    std::vector<Ptr<StaWifiMac>> m_staMacs;       ///< STA wifi MACs
+    uint8_t m_nStations;                          ///< number of stations to create
+    uint16_t m_lastAid;                           ///< AID of last associated station
+
+  private:
+    /**
+     * Reset the given PHY helper, use the given strings to set the ChannelSettings
+     * attribute of the PHY objects to create, and attach them to the given spectrum
+     * channels appropriately.
+     *
+     * \param helper the given PHY helper
+     * \param channels the strings specifying the operating channels to configure
+     * \param channel the created spectrum channel
+     */
+    void SetChannels(SpectrumWifiPhyHelper& helper,
+                     const std::vector<std::string>& channels,
+                     Ptr<MultiModelSpectrumChannel> channel);
+
+    /**
+     * Set the SSID on the next station that needs to start the association procedure.
+     * This method is connected to the ApWifiMac's AssociatedSta trace source.
+     * Start generating traffic (if needed) when all stations are associated.
+     *
+     * \param aid the AID assigned to the previous associated STA
+     */
+    void SetSsid(uint16_t aid, Mac48Address /* addr */);
+
+    /**
+     * Start the generation of traffic (needs to be overridden)
+     */
+    virtual void StartTraffic()
+    {
+    }
+};
+
+MultiLinkOperationsTestBase::MultiLinkOperationsTestBase(const std::string& name,
+                                                         uint8_t nStations,
+                                                         std::vector<std::string> staChannels,
+                                                         std::vector<std::string> apChannels,
+                                                         std::vector<uint8_t> fixedPhyBands)
+    : TestCase(name),
       m_staChannels(staChannels),
       m_apChannels(apChannels),
-      m_setupLinks(setupLinks),
-      m_fixedPhyBands(fixedPhyBands)
+      m_fixedPhyBands(fixedPhyBands),
+      m_staMacs(nStations),
+      m_nStations(nStations),
+      m_lastAid(0)
 {
 }
 
-MultiLinkSetupTest::~MultiLinkSetupTest()
+void
+MultiLinkOperationsTestBase::CheckAddresses(Ptr<const WifiPsdu> psdu,
+                                            std::optional<Direction> direction)
 {
+    std::optional<Mac48Address> apAddr;
+    std::optional<Mac48Address> staAddr;
+
+    // direction for Data frames is derived from ToDS/FromDS flags
+    if (psdu->GetHeader(0).IsQosData())
+    {
+        direction = (!psdu->GetHeader(0).IsToDs() && psdu->GetHeader(0).IsFromDs()) ? DL : UL;
+    }
+    NS_ASSERT(direction);
+
+    if (direction == DL)
+    {
+        if (!psdu->GetAddr1().IsGroup())
+        {
+            staAddr = psdu->GetAddr1();
+        }
+        apAddr = psdu->GetAddr2();
+    }
+    else
+    {
+        if (!psdu->GetAddr1().IsGroup())
+        {
+            apAddr = psdu->GetAddr1();
+        }
+        staAddr = psdu->GetAddr2();
+    }
+
+    if (apAddr)
+    {
+        bool found = false;
+        for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
+        {
+            if (m_apMac->GetFrameExchangeManager(linkId)->GetAddress() == *apAddr)
+            {
+                found = true;
+                break;
+            }
+        }
+        NS_TEST_EXPECT_MSG_EQ(found,
+                              true,
+                              "Address " << *apAddr << " is not an AP device address. "
+                                         << "PSDU: " << *psdu);
+    }
+
+    if (staAddr)
+    {
+        bool found = false;
+        for (uint8_t i = 0; i < m_nStations; i++)
+        {
+            for (uint8_t linkId = 0; linkId < m_staMacs[i]->GetNLinks(); linkId++)
+            {
+                if (m_staMacs[i]->GetFrameExchangeManager(linkId)->GetAddress() == *staAddr)
+                {
+                    found = true;
+                    break;
+                }
+            }
+            if (found)
+            {
+                break;
+            }
+        }
+        NS_TEST_EXPECT_MSG_EQ(found,
+                              true,
+                              "Address " << *staAddr << " is not a STA device address. "
+                                         << "PSDU: " << *psdu);
+    }
 }
 
 void
-MultiLinkSetupTest::Transmit(uint8_t linkId,
-                             std::string context,
-                             WifiConstPsduMap psduMap,
-                             WifiTxVector txVector,
-                             double txPowerW)
+MultiLinkOperationsTestBase::Transmit(uint8_t linkId,
+                                      std::string context,
+                                      WifiConstPsduMap psduMap,
+                                      WifiTxVector txVector,
+                                      double txPowerW)
 {
     m_txPsdus.push_back({Simulator::Now(), psduMap, txVector, linkId});
 
-    std::stringstream ss;
-    ss << std::setprecision(10) << "PSDU #" << m_txPsdus.size() << " Link ID " << +linkId << " "
-       << psduMap.begin()->second->GetHeader(0).GetTypeString() << " #MPDUs "
-       << psduMap.begin()->second->GetNMpdus() << " duration/ID "
-       << psduMap.begin()->second->GetHeader(0).GetDuration()
-       << " RA = " << psduMap.begin()->second->GetAddr1()
-       << " TA = " << psduMap.begin()->second->GetAddr2();
-    if (psduMap.begin()->second->GetHeader(0).IsQosData())
+    for (const auto& [aid, psdu] : psduMap)
     {
-        ss << " TID = " << +psduMap.begin()->second->GetHeader(0).GetQosTid();
+        std::stringstream ss;
+        ss << std::setprecision(10) << "PSDU #" << m_txPsdus.size() << " Link ID " << +linkId << " "
+           << psdu->GetHeader(0).GetTypeString() << " #MPDUs " << psdu->GetNMpdus()
+           << " duration/ID " << psdu->GetHeader(0).GetDuration() << " RA = " << psdu->GetAddr1()
+           << " TA = " << psdu->GetAddr2() << " ADDR3 = " << psdu->GetHeader(0).GetAddr3()
+           << " ToDS = " << psdu->GetHeader(0).IsToDs()
+           << " FromDS = " << psdu->GetHeader(0).IsFromDs();
+        if (psdu->GetHeader(0).IsQosData())
+        {
+            ss << " seqNo = {";
+            for (auto& mpdu : *PeekPointer(psdu))
+            {
+                ss << mpdu->GetHeader().GetSequenceNumber() << ",";
+            }
+            ss << "} TID = " << +psdu->GetHeader(0).GetQosTid();
+        }
+        NS_LOG_INFO(ss.str());
     }
-    NS_LOG_INFO(ss.str());
     NS_LOG_INFO("TXVECTOR = " << txVector << "\n");
 }
 
 void
-MultiLinkSetupTest::SetChannels(
-    SpectrumWifiPhyHelper& helper,
-    const std::vector<std::string>& channels,
-    const std::map<WifiPhyBand, Ptr<MultiModelSpectrumChannel>>& channelMap)
+MultiLinkOperationsTestBase::SetChannels(SpectrumWifiPhyHelper& helper,
+                                         const std::vector<std::string>& channels,
+                                         Ptr<MultiModelSpectrumChannel> channel)
 {
     helper = SpectrumWifiPhyHelper(channels.size());
     helper.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
@@ -351,34 +433,14 @@
     uint8_t linkId = 0;
     for (const auto& str : channels)
     {
-        helper.Set(linkId, "ChannelSettings", StringValue(str));
-        helper.SetChannel(linkId, channelMap.at(GetPhyBandFromChannelStr(str)));
-
-        linkId++;
+        helper.Set(linkId++, "ChannelSettings", StringValue(str));
     }
-}
 
-WifiPhyBand
-MultiLinkSetupTest::GetPhyBandFromChannelStr(const std::string& str)
-{
-    if (str.find("2_4GHZ") != std::string::npos)
-    {
-        return WIFI_PHY_BAND_2_4GHZ;
-    }
-    if (str.find("5GHZ") != std::string::npos)
-    {
-        return WIFI_PHY_BAND_5GHZ;
-    }
-    if (str.find("6GHZ") != std::string::npos)
-    {
-        return WIFI_PHY_BAND_6GHZ;
-    }
-    NS_ABORT_MSG("Band in channel settings must be specified");
-    return WIFI_PHY_BAND_UNSPECIFIED;
+    helper.SetChannel(channel);
 }
 
 void
-MultiLinkSetupTest::DoRun()
+MultiLinkOperationsTestBase::DoSetup()
 {
     RngSeedManager::SetSeed(1);
     RngSeedManager::SetRun(2);
@@ -387,25 +449,24 @@
     NodeContainer wifiApNode;
     wifiApNode.Create(1);
 
-    NodeContainer wifiStaNode;
-    wifiStaNode.Create(1);
+    NodeContainer wifiStaNodes;
+    wifiStaNodes.Create(m_nStations);
 
     WifiHelper wifi;
     // wifi.EnableLogComponents ();
     wifi.SetStandard(WIFI_STANDARD_80211be);
     wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
                                  "DataMode",
-                                 StringValue("EhtMcs0"));
+                                 StringValue("EhtMcs0"),
+                                 "ControlMode",
+                                 StringValue("HtMcs0"));
 
-    std::map<WifiPhyBand, Ptr<MultiModelSpectrumChannel>> channelMap = {
-        {WIFI_PHY_BAND_2_4GHZ, CreateObject<MultiModelSpectrumChannel>()},
-        {WIFI_PHY_BAND_5GHZ, CreateObject<MultiModelSpectrumChannel>()},
-        {WIFI_PHY_BAND_6GHZ, CreateObject<MultiModelSpectrumChannel>()}};
+    auto channel = CreateObject<MultiModelSpectrumChannel>();
 
     SpectrumWifiPhyHelper staPhyHelper;
     SpectrumWifiPhyHelper apPhyHelper;
-    SetChannels(staPhyHelper, m_staChannels, channelMap);
-    SetChannels(apPhyHelper, m_apChannels, channelMap);
+    SetChannels(staPhyHelper, m_staChannels, channel);
+    SetChannels(apPhyHelper, m_apChannels, channel);
 
     for (const auto& linkId : m_fixedPhyBands)
     {
@@ -413,12 +474,17 @@
     }
 
     WifiMacHelper mac;
-    Ssid ssid = Ssid("ns-3-ssid");
-    mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid), "ActiveProbing", BooleanValue(false));
-
-    NetDeviceContainer staDevices = wifi.Install(staPhyHelper, mac, wifiStaNode);
-
-    mac.SetType("ns3::ApWifiMac", "Ssid", SsidValue(ssid), "BeaconGeneration", BooleanValue(true));
+    mac.SetType("ns3::StaWifiMac", // default SSID
+                "ActiveProbing",
+                BooleanValue(false));
+
+    NetDeviceContainer staDevices = wifi.Install(staPhyHelper, mac, wifiStaNodes);
+
+    mac.SetType("ns3::ApWifiMac",
+                "Ssid",
+                SsidValue(Ssid("ns-3-ssid")),
+                "BeaconGeneration",
+                BooleanValue(true));
 
     NetDeviceContainer apDevices = wifi.Install(apPhyHelper, mac, wifiApNode);
 
@@ -439,10 +505,14 @@
 
     mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
     mobility.Install(wifiApNode);
-    mobility.Install(wifiStaNode);
+    mobility.Install(wifiStaNodes);
 
     m_apMac = DynamicCast<ApWifiMac>(DynamicCast<WifiNetDevice>(apDevices.Get(0))->GetMac());
-    m_staMac = DynamicCast<StaWifiMac>(DynamicCast<WifiNetDevice>(staDevices.Get(0))->GetMac());
+    for (uint8_t i = 0; i < m_nStations; i++)
+    {
+        m_staMacs[i] =
+            DynamicCast<StaWifiMac>(DynamicCast<WifiNetDevice>(staDevices.Get(i))->GetMac());
+    }
 
     // Trace PSDUs passed to the PHY on all devices
     for (uint8_t linkId = 0; linkId < StaticCast<WifiNetDevice>(apDevices.Get(0))->GetNPhys();
@@ -450,16 +520,134 @@
     {
         Config::Connect("/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/Phys/" +
                             std::to_string(linkId) + "/PhyTxPsduBegin",
-                        MakeCallback(&MultiLinkSetupTest::Transmit, this).Bind(linkId));
+                        MakeCallback(&MultiLinkOperationsTestBase::Transmit, this).Bind(linkId));
     }
-    for (uint8_t linkId = 0; linkId < StaticCast<WifiNetDevice>(staDevices.Get(0))->GetNPhys();
-         linkId++)
+    for (uint8_t i = 0; i < m_nStations; i++)
     {
-        Config::Connect("/NodeList/1/DeviceList/*/$ns3::WifiNetDevice/Phys/" +
-                            std::to_string(linkId) + "/PhyTxPsduBegin",
-                        MakeCallback(&MultiLinkSetupTest::Transmit, this).Bind(linkId));
+        for (uint8_t linkId = 0; linkId < StaticCast<WifiNetDevice>(staDevices.Get(i))->GetNPhys();
+             linkId++)
+        {
+            Config::Connect(
+                "/NodeList/" + std::to_string(i + 1) + "/DeviceList/*/$ns3::WifiNetDevice/Phys/" +
+                    std::to_string(linkId) + "/PhyTxPsduBegin",
+                MakeCallback(&MultiLinkOperationsTestBase::Transmit, this).Bind(linkId));
+        }
     }
 
+    // schedule ML setup for one station at a time
+    m_apMac->TraceConnectWithoutContext("AssociatedSta",
+                                        MakeCallback(&MultiLinkOperationsTestBase::SetSsid, this));
+    Simulator::Schedule(Seconds(0), [&]() { m_staMacs[0]->SetSsid(Ssid("ns-3-ssid")); });
+}
+
+void
+MultiLinkOperationsTestBase::SetSsid(uint16_t aid, Mac48Address /* addr */)
+{
+    if (m_lastAid == aid)
+    {
+        // another STA of this non-AP MLD has already fired this callback
+        return;
+    }
+    m_lastAid = aid;
+
+    // make the next STA to start ML discovery & setup
+    if (aid < m_nStations)
+    {
+        m_staMacs[aid]->SetSsid(Ssid("ns-3-ssid"));
+        return;
+    }
+    // wait some time (5ms) to allow the completion of association before generating traffic
+    Simulator::Schedule(MilliSeconds(5), &MultiLinkOperationsTestBase::StartTraffic, this);
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Multi-Link Discovery & Setup test.
+ *
+ * This test sets up an AP MLD and a non-AP MLD having a variable number of links.
+ * The RF channels to set each link to are provided as input parameters through the test
+ * case constructor, along with the identifiers (starting at 0) of the links that cannot
+ * switch PHY band (if any). The links that are expected to be setup are also provided as input
+ * parameters. This test verifies that the management frames exchanged during ML discovery
+ * and ML setup contain the expected values and that the two MLDs setup the expected links.
+ */
+class MultiLinkSetupTest : public MultiLinkOperationsTestBase
+{
+  public:
+    /**
+     * Constructor
+     *
+     * \param staChannels the strings specifying the operating channels for the STA
+     * \param apChannels the strings specifying the operating channels for the AP
+     * \param setupLinks a list of links (STA link ID, AP link ID) that are expected to be setup
+     * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
+     */
+    MultiLinkSetupTest(std::vector<std::string> staChannels,
+                       std::vector<std::string> apChannels,
+                       std::vector<std::pair<uint8_t, uint8_t>> setupLinks,
+                       std::vector<uint8_t> fixedPhyBands = {});
+    ~MultiLinkSetupTest() override = default;
+
+  protected:
+    void DoRun() override;
+
+  private:
+    /**
+     * Check correctness of Multi-Link Setup procedure.
+     */
+    void CheckMlSetup();
+
+    /**
+     * Check that links that are not setup on the non-AP MLD are disabled.
+     */
+    void CheckDisabledLinks();
+
+    /**
+     * Check correctness of the given Beacon frame.
+     *
+     * \param mpdu the given Beacon frame
+     * \param linkId the ID of the link on which the Beacon frame was transmitted
+     */
+    void CheckBeacon(Ptr<WifiMpdu> mpdu, uint8_t linkId);
+
+    /**
+     * Check correctness of the given Association Request frame.
+     *
+     * \param mpdu the given Association Request frame
+     * \param linkId the ID of the link on which the Association Request frame was transmitted
+     */
+    void CheckAssocRequest(Ptr<WifiMpdu> mpdu, uint8_t linkId);
+
+    /**
+     * Check correctness of the given Association Response frame.
+     *
+     * \param mpdu the given Association Response frame
+     * \param linkId the ID of the link on which the Association Response frame was transmitted
+     */
+    void CheckAssocResponse(Ptr<WifiMpdu> mpdu, uint8_t linkId);
+
+    /// expected links to setup (STA link ID, AP link ID)
+    const std::vector<std::pair<uint8_t, uint8_t>> m_setupLinks;
+};
+
+MultiLinkSetupTest::MultiLinkSetupTest(std::vector<std::string> staChannels,
+                                       std::vector<std::string> apChannels,
+                                       std::vector<std::pair<uint8_t, uint8_t>> setupLinks,
+                                       std::vector<uint8_t> fixedPhyBands)
+    : MultiLinkOperationsTestBase("Check correctness of Multi-Link Setup",
+                                  1,
+                                  staChannels,
+                                  apChannels,
+                                  fixedPhyBands),
+      m_setupLinks(setupLinks)
+{
+}
+
+void
+MultiLinkSetupTest::DoRun()
+{
     Simulator::Schedule(MilliSeconds(500), &MultiLinkSetupTest::CheckMlSetup, this);
 
     Simulator::Stop(Seconds(1.5));
@@ -502,6 +690,8 @@
 {
     NS_ABORT_IF(mpdu->GetHeader().GetType() != WIFI_MAC_MGT_BEACON);
 
+    CheckAddresses(Create<WifiPsdu>(mpdu, false), MultiLinkOperationsTestBase::DL);
+
     NS_TEST_EXPECT_MSG_EQ(m_apMac->GetFrameExchangeManager(linkId)->GetAddress(),
                           mpdu->GetHeader().GetAddr2(),
                           "TA of Beacon frame is not the address of the link it is transmitted on");
@@ -558,15 +748,17 @@
 {
     NS_ABORT_IF(mpdu->GetHeader().GetType() != WIFI_MAC_MGT_ASSOCIATION_REQUEST);
 
+    CheckAddresses(Create<WifiPsdu>(mpdu, false), MultiLinkOperationsTestBase::UL);
+
     NS_TEST_EXPECT_MSG_EQ(
-        m_staMac->GetFrameExchangeManager(linkId)->GetAddress(),
+        m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress(),
         mpdu->GetHeader().GetAddr2(),
         "TA of Assoc Request frame is not the address of the link it is transmitted on");
     MgtAssocRequestHeader assoc;
     mpdu->GetPacket()->PeekHeader(assoc);
     const auto& mle = assoc.GetMultiLinkElement();
 
-    if (m_apMac->GetNLinks() == 1 || m_staMac->GetNLinks() == 1)
+    if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetNLinks() == 1)
     {
         NS_TEST_EXPECT_MSG_EQ(mle.has_value(),
                               false,
@@ -576,7 +768,7 @@
 
     NS_TEST_EXPECT_MSG_EQ(mle.has_value(), true, "No Multi-Link Element in Assoc Request frame");
     NS_TEST_EXPECT_MSG_EQ(mle->GetMldMacAddress(),
-                          m_staMac->GetAddress(),
+                          m_staMacs[0]->GetAddress(),
                           "Incorrect MLD Address advertised in Multi-Link Element");
     NS_TEST_EXPECT_MSG_EQ(mle->GetNPerStaProfileSubelements(),
                           m_setupLinks.size() - 1,
@@ -588,7 +780,7 @@
                               true,
                               "Per-STA Profile must contain STA MAC address");
         // find ID of the local link corresponding to this subelement
-        auto staLinkId = m_staMac->GetLinkIdByAddress(perStaProfile.GetStaMacAddress());
+        auto staLinkId = m_staMacs[0]->GetLinkIdByAddress(perStaProfile.GetStaMacAddress());
         NS_TEST_EXPECT_MSG_EQ(
             staLinkId.has_value(),
             true,
@@ -618,6 +810,8 @@
 {
     NS_ABORT_IF(mpdu->GetHeader().GetType() != WIFI_MAC_MGT_ASSOCIATION_RESPONSE);
 
+    CheckAddresses(Create<WifiPsdu>(mpdu, false), MultiLinkOperationsTestBase::DL);
+
     NS_TEST_EXPECT_MSG_EQ(
         m_apMac->GetFrameExchangeManager(linkId)->GetAddress(),
         mpdu->GetHeader().GetAddr2(),
@@ -626,7 +820,7 @@
     mpdu->GetPacket()->PeekHeader(assoc);
     const auto& mle = assoc.GetMultiLinkElement();
 
-    if (m_apMac->GetNLinks() == 1 || m_staMac->GetNLinks() == 1)
+    if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetNLinks() == 1)
     {
         NS_TEST_EXPECT_MSG_EQ(
             mle.has_value(),
@@ -679,21 +873,21 @@
     /**
      * Check outcome of Multi-Link Setup
      */
-    NS_TEST_EXPECT_MSG_EQ(m_staMac->IsAssociated(), true, "Expected the STA to be associated");
+    NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->IsAssociated(), true, "Expected the STA to be associated");
 
     for (const auto& [staLinkId, apLinkId] : m_setupLinks)
     {
-        auto staAddr = m_staMac->GetFrameExchangeManager(staLinkId)->GetAddress();
+        auto staAddr = m_staMacs[0]->GetFrameExchangeManager(staLinkId)->GetAddress();
         auto apAddr = m_apMac->GetFrameExchangeManager(apLinkId)->GetAddress();
 
-        auto staRemoteMgr = m_staMac->GetWifiRemoteStationManager(staLinkId);
+        auto staRemoteMgr = m_staMacs[0]->GetWifiRemoteStationManager(staLinkId);
         auto apRemoteMgr = m_apMac->GetWifiRemoteStationManager(apLinkId);
 
         // STA side
-        NS_TEST_EXPECT_MSG_EQ(m_staMac->GetFrameExchangeManager(staLinkId)->GetBssid(),
+        NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetFrameExchangeManager(staLinkId)->GetBssid(),
                               apAddr,
                               "Unexpected BSSID for STA link ID " << +staLinkId);
-        if (m_apMac->GetNLinks() > 1 && m_staMac->GetNLinks() > 1)
+        if (m_apMac->GetNLinks() > 1 && m_staMacs[0]->GetNLinks() > 1)
         {
             NS_TEST_EXPECT_MSG_EQ((staRemoteMgr->GetMldAddress(apAddr) == m_apMac->GetAddress()),
                                   true,
@@ -709,13 +903,14 @@
                               true,
                               "Expecting STA " << staAddr << " to be associated on link "
                                                << +apLinkId);
-        if (m_apMac->GetNLinks() > 1 && m_staMac->GetNLinks() > 1)
+        if (m_apMac->GetNLinks() > 1 && m_staMacs[0]->GetNLinks() > 1)
         {
-            NS_TEST_EXPECT_MSG_EQ((apRemoteMgr->GetMldAddress(staAddr) == m_staMac->GetAddress()),
-                                  true,
-                                  "Incorrect MLD address stored by AP on link ID " << +apLinkId);
             NS_TEST_EXPECT_MSG_EQ(
-                (apRemoteMgr->GetAffiliatedStaAddress(m_staMac->GetAddress()) == staAddr),
+                (apRemoteMgr->GetMldAddress(staAddr) == m_staMacs[0]->GetAddress()),
+                true,
+                "Incorrect MLD address stored by AP on link ID " << +apLinkId);
+            NS_TEST_EXPECT_MSG_EQ(
+                (apRemoteMgr->GetAffiliatedStaAddress(m_staMacs[0]->GetAddress()) == staAddr),
                 true,
                 "Incorrect affiliated address stored by AP on link ID " << +apLinkId);
         }
